// WinModPatternDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include <wingdi.h>
#include "WinModFileTypes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CWinModPatternDlg 

CWinModPatternDlg::CWinModPatternDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinModPatternDlg::IDD, pParent), m_cfFixedFont(NULL)
{
	//{{AFX_DATA_INIT(CWinModPatternDlg)
	//}}AFX_DATA_INIT
	m_WindowOpen=false;
}

CWinModPatternDlg::~CWinModPatternDlg()
{
	if (m_cfFixedFont)
	{
		m_cfFixedFont->Detach();
		delete m_cfFixedFont;
	}
	m_WindowOpen=false;
}

void CWinModPatternDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinModPatternDlg)
	DDX_Control(pDX, IDC_EDIT_PatternNr, m_PatternNummerCtrl);
	DDX_Control(pDX, IDC_LIST_Pattern, m_ListPattern);
	DDX_Control(pDX, IDC_PreviousPattern, m_PrevPattern);
	DDX_Control(pDX, IDC_NextPattern, m_NextPattern);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWinModPatternDlg, CDialog)
	//{{AFX_MSG_MAP(CWinModPatternDlg)
	ON_BN_CLICKED(IDC_PreviousPattern, OnPreviousPattern)
	ON_BN_CLICKED(IDC_NextPattern, OnNextPattern)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CWinModPatternDlg 

void CWinModPatternDlg::OnOK()
{
	m_WindowOpen=false;
	CDialog::OnOK();
}

void CWinModPatternDlg::OnCancel()
{
	m_WindowOpen=false;
	CDialog::OnCancel();
}

BOOL CWinModPatternDlg::OnInitDialog() 
{
	extern CWinModApp theApp; // Das Applicationopjekt
	HICON hIconFor, hIconBack;

	CDialog::OnInitDialog();

	hIconFor=theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_FORWARD));
	hIconBack=theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_BACKWARDS));
	m_NextPattern.SetIcon(hIconFor);
	m_PrevPattern.SetIcon(hIconBack);

    if (!m_cfFixedFont)
	{
		m_cfFixedFont = new CFont;
		m_cfFixedFont->CreateStockObject(SYSTEM_FIXED_FONT);
	}
	/*m_cfFixedFont->CreateStockObject(ANSI_FIXED_FONT);*/

	m_ListPattern.SetFont(m_cfFixedFont, true); // redraw = true*/

	CDC *pDC = m_ListPattern.GetDC();
	CSize sz = pDC->GetTextExtent(_T("H"));
	m_ListPattern.ReleaseDC(pDC);
	m_ListPattern.SetHorizontalExtent(sz.cx*20*ThisMod->nChannels);
	
	// Und noch ein Boldfont, der aus dem Fixed-Font erzeugt wird...
	//CFont * m_cfBoldFont = new CFont;
    //LOGFONT oldFont;
    //m_cfFixedFont->GetObject(sizeof(LOGFONT), &oldFont);
	//oldFont.lfUnderline = TRUE;
    //m_cfBoldFont->CreateFontIndirect(&oldFont);

	actDisplayedPatternNummer = -1;
	actTopRow = -1;
	DisplayPattern(actPatternNummer=0, 0);
	
	m_WindowOpen=true;
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CWinModPatternDlg::OnPreviousPattern() 
{
	if (actPatternNummer==0) actPatternNummer=ThisMod->nPattern;
	else actPatternNummer--;
	DisplayPattern(actPatternNummer, 0);
}

void CWinModPatternDlg::OnNextPattern() 
{
	actPatternNummer++;
	if (actPatternNummer>ThisMod->nPattern) actPatternNummer=0;
	DisplayPattern(actPatternNummer, 0);
}

/////////////////////////////////////////////////////////////////////////////
// Weitere Methoden:

void CWinModPatternDlg::DisplayActPosition(unsigned int actPattern, unsigned int actRow)
{
	if (!m_WindowOpen) return;
	int topRow = 0;
	if (actRow>11 && actRow<55) 
	{
		topRow = actRow-11;
		actRow = 11;
	}
	else
	if (actRow>=55)
	{
		topRow = 44;
		actRow -= 44;
	}
	DisplayPattern(actPattern, topRow);
	m_ListPattern.SetCurSel(actRow);
}

void CWinModPatternDlg::DisplayPattern(unsigned int nr, unsigned int topRow)
{
	if (nr>ThisMod->nPattern || (actDisplayedPatternNummer==nr && actTopRow==topRow)) return;

	m_ListPattern.SetRedraw(false);
	m_ListPattern.ResetContent();
	
	actDisplayedPatternNummer = nr;
	actTopRow = topRow;

	char str[30];
	sprintf(str,"%02X",nr);
	m_PatternNummerCtrl.SetWindowText(str);

	struct PatternData *actPattern=ThisMod->Pattern[nr];
	unsigned int actRow=0;

	char *oneLine = new char[ThisMod->nChannels*20];
	
	for (unsigned int row=0; row<64; row++)
	{
		sprintf(oneLine,"%02X ",row);
		char *s=oneLine+strlen(oneLine);

		for (unsigned int voice=0; voice<ThisMod->nChannels; voice++)
		{
			if(!actPattern || voice!=actPattern->ChannelIndex || actPattern->TimeIndex!=row) 
			{
				strcpy(str,"... .. .. ... | ");
			}
			else
			{
				if (row>=topRow)
				{
					char tonVolumeS[5];
					char tonInstrument[5];
					char tonEffekt[5];

					if (actPattern->Volume==-1) 
						strcpy(tonVolumeS," .."); 
					else 
						sprintf(tonVolumeS,"v%02X",actPattern->Volume);
					
					if (!actPattern->SampleIndex) 
						strcpy(tonInstrument,".."); 
					else 
						sprintf(tonInstrument,"%02X",actPattern->SampleIndex);
					
					if (!actPattern->Effekt && !actPattern->Effektop) 
						strcpy(tonEffekt,"..."); 
					else 
						sprintf(tonEffekt,"%1.1X%1.1X%1.1X",actPattern->Effekt, actPattern->Effektop>>4, actPattern->Effektop&0xF);


					sprintf(str,"%s %s%s %s | ", (!actPattern->Ton)?"...":notes[actPattern->noteIndex+12*actPattern->noteOctave].NoteStr/*GetNote(RoundTon(actPattern->Ton))*/, tonInstrument, tonVolumeS, tonEffekt);
				}
				else
					*str=0;

				actPattern=actPattern->Next;
			}
			strcpy(s,str);
			s+=strlen(str);
			*s=0;
		}

		if (row>=topRow) 
		{
			actRow++; 
			m_ListPattern.AddString(oneLine);
		}
	}
	delete [] oneLine;
	m_ListPattern.SetRedraw(true);
	m_ListPattern.Invalidate();
}
